; ColdAngel/theme.jl

;; ColdAngel - a sawfish theme

;; Copyright (C) 2000 Michael Spunt <spuntik@gmx.de>

(let*
    ((title-width
      (lambda (w)
	(let
	    ((w-width (car (window-dimensions w))))
	  (max 0 (min (- w-width 100) (text-width (window-name w)))))))
     
     (bottom-images (make-image "bottom.png"))
     (top-left-images (list (make-image "top_left_inactive.png") (make-image "top_left.png")))
     (top-left2-images (list (make-image "top_left2_inactive.png") (make-image "top_left2.png")))
     (title-images (make-image "title.png"))
     (top-curves-images (make-image "top_center.png"))
     (top-border-images (make-image "bottom.png"))
     (top-right-images (make-image "top_right.png"))
     (top-right-shaped-images (make-image "top_right_s.png"))
     (bottom-left-images (make-image "bl.png"))
     (bottom-right-images (make-image "br.png"))
     (menu-images (list (make-image "menu_normal.png") (make-image "menu_active.png")))
     (menu-shaped-images (list (make-image "menu_shaped_normal.png") (make-image "menu_shaped_active.png")))
     (left-images (make-image "left.png"))
     (right-images (make-image "right.png"))
    
     (frame `(((background . ,top-left-images)
	       (left-edge . -20)
	       (top-edge . 0)
	       (class . top-left-corner))

	      ((background . ,top-left2-images)
	       (left-edge . -0)
	       (top-edge . -20)
	       (class . top-left-corner))

	      ((background . ,title-images)
	       (foreground . "black")
	       (text . ,window-name)
	       (x-justify . 4)
	       (y-justify . center)
	       (top-edge . -15)
	       (left-edge . 75)
	       (width . ,(lambda (w) (+ (title-width w) 15)))
	       (class . title))

	      ((background . ,menu-images)
	       (top-edge . -20)
	       (left-edge . -20)
	       (class . menu-button))

	      ((background . ,top-curves-images)
	       (left-edge . ,(lambda (w) (+ (title-width w) 90)))
	       (top-edge . -15)
	       (class . title))

	      ((background . ,top-border-images)
	       (top-edge . -5)
	       (left-edge . ,(lambda (w) (+ (title-width w) 95)))
	       (right-edge . 0)
	       (class . top-border))

	      ((background . ,left-images)
	       (left-edge . -5)
	       (top-edge . 80)
	       (bottom-edge . 0)
	       (class . left-border))

	      ((background . ,top-right-images)
	       (right-edge . -5)
	       (top-edge . -5)
	       (class . top-right-corner))

	      ((background . ,right-images)
	       (right-edge . -5)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . right-border))

	      ((background . ,bottom-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -5)
	       (class . bottom-border))

	      ((background . ,bottom-left-images)
	       (left-edge . -5)
	       (bottom-edge . -5)
	       (class . bottom-left-corner))

	      ((background . ,bottom-right-images)
	       (right-edge . -5)
	       (bottom-edge . -5)
	       (class . bottom-right-corner))))

       (shaped-frame `(((background . ,top-left2-images)
	       (left-edge . -0)
	       (top-edge . -20)
	       (class . top-left-corner))

		       ((background . ,title-images)
			(foreground . "black")
			(text . ,window-name)
			(x-justify . 4)
			(y-justify . center)
			(top-edge . -15)
			(left-edge . 75)
			(width . ,(lambda (w) (+ (title-width w) 15)))
			(class . title))

		       ((background . ,menu-shaped-images)
			(top-edge . -20)
			(left-edge . -20)
			(class . menu-button))

		       ((background . ,top-curves-images)
			(left-edge . ,(lambda (w) (+ (title-width w) 90)))
			(top-edge . -15)
			(class . title))

		       ((background . ,top-border-images)
			(top-edge . -5)
			(left-edge . ,(lambda (w) (+ (title-width w) 95)))
			(width . 5)
			(class . title))

		       ((background . ,top-right-shaped-images)
			(left-edge . ,(lambda (w) (+ (title-width w) 100)))
			(top-edge . -5)
			(class . top-right-corner))))

     (transient-frame `(((background . ,top-left-images)
	       (left-edge . -20)
	       (top-edge . 0)
	       (class . top-left-corner))

	      ((background . ,top-left2-images)
	       (left-edge . -0)
	       (top-edge . -20)
	       (class . top-left-corner))

	      ((background . ,title-images)
	       (foreground . "black")
	       (text . ,window-name)
	       (x-justify . 4)
	       (y-justify . center)
	       (top-edge . -15)
	       (left-edge . 75)
	       (width . ,(lambda (w) (+ (title-width w) 15)))
	       (class . title))

	      ((background . ,menu-images)
	       (top-edge . -20)
	       (left-edge . -20)
	       (class . menu-button))

	      ((background . ,top-curves-images)
	       (left-edge . ,(lambda (w) (+ (title-width w) 90)))
	       (top-edge . -15)
	       (class . title))

	      ((background . ,top-border-images)
	       (top-edge . -5)
	       (left-edge . ,(lambda (w) (+ (title-width w) 95)))
	       (right-edge . 0)
	       (class . top-border))

	      ((background . ,left-images)
	       (left-edge . -5)
	       (top-edge . 80)
	       (bottom-edge . 0)
	       (class . left-border))

	      ((background . ,top-right-images)
	       (right-edge . -5)
	       (top-edge . -5)
	       (class . top-right-corner))

	      ((background . ,right-images)
	       (right-edge . -5)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . right-border))

	      ((background . ,bottom-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -5)
	       (class . bottom-border))

	      ((background . ,bottom-left-images)
	       (left-edge . -5)
	       (bottom-edge . -5)
	       (class . bottom-left-corner))

	      ((background . ,bottom-right-images)
	       (right-edge . -5)
	       (bottom-edge . -5)
	       (class . bottom-right-corner))))

       (shaped-transient-frame `(((background . ,top-left2-images)
	       (left-edge . -0)
	       (top-edge . -20)
	       (class . top-left-corner))

		       ((background . ,title-images)
			(foreground . "black")
			(text . ,window-name)
			(x-justify . 4)
			(y-justify . center)
			(top-edge . -15)
			(left-edge . 75)
			(width . ,(lambda (w) (+ (title-width w) 15)))
			(class . title))

		       ((background . ,menu-shaped-images)
			(top-edge . -20)
			(left-edge . -20)
			(class . menu-button))

		       ((background . ,top-curves-images)
			(left-edge . ,(lambda (w) (+ (title-width w) 90)))
			(top-edge . -15)
			(class . title))

		       ((background . ,top-border-images)
			(top-edge . -5)
			(left-edge . ,(lambda (w) (+ (title-width w) 95)))
			(width . 5)
			(class . title))

		       ((background . ,top-right-shaped-images)
			(left-edge . ,(lambda (w) (+ (title-width w) 100)))
			(top-edge . -5)
			(class . top-right-corner)))))
  
  (add-frame-style 'ColdAngel
		   (lambda (w type)
		     (cond ((eq type 'shaped)
			    shaped-frame)
			   ((eq type 'transient)
			    transient-frame)
			   ((eq type 'shaped-transient)
			    shaped-transient-frame)
			   ((eq type 'unframed)
			    nil-frame)
			   (t
			    frame))))

  (call-after-property-changed
   'WM_NAME (lambda ()
	      (rebuild-frames-with-style 'ColdAngel))))